﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=8.5
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
End Sub
Sub getIndexListWordsSpaces(str As String) As List
	Dim indexF As List
	Dim index As Int = 0
	Dim index0 As Int
	indexF.Initialize
	indexF.Add(index)
	index = str.IndexOf2(" ",index+1)
	indexF.Add(index)
	Do While index <> -1
		index0 = index
		index = str.IndexOf2(" ",index+1)
		If index > index0 + 1 Then
			indexF.Add(index0+1)
			indexF.Add(index)
		Else
			If index = -1 Then
				indexF.Add(index0+1)
			Else
				indexF.Add(index)
			End If
		End If
	Loop
	If str.SubString(indexF.Get(indexF.Size-1)) = "" Then
		indexF.RemoveAt(indexF.Size-1)
	End If
	Return indexF
End Sub

Sub getListWordsSpaces(str As String, listIndexM As List) As List
	Dim listWordsSpaces As List
	listWordsSpaces.Initialize
	For i=0 To listIndexM.Size-2
		listWordsSpaces.Add(str.SubString2(listIndexM.Get(i),listIndexM.Get(i+1)))
	Next
	listWordsSpaces.Add(str.SubString(listIndexM.Get(i)))
	Return listWordsSpaces
End Sub

Private Sub AddBackgroundPanels
	For Each x As B4XView In BBCodeView1.sv.ScrollViewInnerPanel.GetAllViewsRecursive
		If x.Tag = "background" Then
			x.RemoveViewFromParent
		End If
	Next
	Dim scale As Float = TextEngine.mScale
	For Each line As BCTextLine In BBCodeView1.Paragraph.TextLines
		For Each un As BCUnbreakableText In line.Unbreakables
			For Each s As BCSingleStyleSection In un.SingleStyleSections
				If WordsToHighlight.Contains(s.Run.Text) Then
					Dim pnl As B4XView = xui.CreatePanel("")
					pnl.Color = 0xFF00D2FF
					pnl.Tag = "background"
					BBCodeView1.sv.ScrollViewInnerPanel.AddView(pnl, BBCodeView1.Padding.Left + s.AbsoluteStartX / scale - 2dip, _
                     BBCodeView1.Padding.Top + (line.BaselineY - s.MaxHeightAboveBaseLine) / scale - 2dip, _
                        s.Width / scale + 4dip, (s.MaxHeightBelowBaseLine + s.MaxHeightAboveBaseLine) / scale + 4dip)
					pnl.SendToBack
				End If
			Next
		Next
	Next
End Sub